.if !defined(PLESK_DEPENDS_MK)
PLESK_DEPENDS_MK= 1

# Create sorted list of dependencies for all depends
# and PRE_ depends.
# Delete invalid packages(witch exists into system but some 
# file from package was not found in system)
# create semaphores for right installed packages. 

# Correct depends list after deleting incorrect packages
# (cut installed packages from depends lists)
sw-install-depends:
	@if [ ! -z "${DEPENDS_FILE}" -a -f "${DEPENDS_FILE}" ]; then \
	    for origin in $$(cat ${DEPENDS_FILE}); do \
		echo "===> install $$origin"; \
		name="$${origin##*/}"; \
		master_origin=$$(cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} -V PKGORIGIN); \
		_pkgname=$$(pkg_info -qO $$master_origin); \
		_need_install=0; \
		_need_upgrade=0; \
		if [ -z "$$_pkgname" ]; then \
		    _need_install=1; \
		else \
		    _update=$$(pkg_version -s $$_pkgname 2>/dev/null | awk '{print $$2}'); \
		    if [ "$$_update" = '<' ]; then \
			if [ "$$master_origin" != "$$origin" ]; then \
			    cd ${PORTSDIR}/${SELF_ORIGIN} && ${MAKE} ${SW_MAKEOPTS} LIST="$$master_origin" sw-delete-depends; \
			    _need_install=1; \
			else \
			    _need_upgrade=1; \
			fi; \
		    else \
			if [ "$$master_origin" != "$$origin" ]; then \
			    _pkgname_self=$$(cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} -V PKGNAME); \
			    if [ "$$_pkgname_self" != "$$_pkgname" ]; then \
				_need_upgrade=1; \
			    fi; \
			fi; \
		    fi; \
		fi; \
		if [ "$$_need_install" -eq 1 ]; then \
		    _pkg=$$(cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} -V PKGNAME); \
		    ${PKG_ADD} ${SW_PACKAGES_DIR}/All/$${_pkg}.tbz 2>/dev/null && flag=0 || flag=1; \
		    if [ "$$flag" -ne 0 ]; then \
			    cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} install; \
			if [ ! -z ${CREATE_PACKAGES} ]; then \
			    cd ${PORTSDIR}/$$origin && ${MAKE} ${SW_MAKEOPTS} package || true; \
			fi; \
		    fi; \
		    ${TOUCH} "${SW_WRKDIR}/.installed.$$name"; \
		else \
		    if [ "$$_need_upgrade" -eq 1 ]; then \
			PKGTOOLS_CONF=${PKGTOOLS_CONF} \
			    ${PORTUPGRADE} ${PORTUPGRADE_FLAGS} -f -P $$origin && \
			    ${TOUCH} "${SW_WRKDIR}/.installed.$$name"; \
		    fi; \
		fi; \
	    done; \
	fi

sw-delete-depends:
	@PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    ${PKG_DEINSTALL} -O -P -f ${LIST} 1>/dev/null 2>&1 || true; \
	for _dep in ${LIST}; do \
	    rm -f "${SW_WRKDIR}/.installed.$${_dep##*/}"; \
	done

sw-pre-depends: sw-do-mkdirs 
	@echo "===> Install pre-depends for ${PKGNAME}:"
	@echo "" > ${CHECKED_FILE}
	@depends="${PRE_DEPENDS}"; \
	${MAKE} ${SW_MAKEOPTS} DEPENDS="$$depends" sw-pre-depends-req
	@depends=$$(cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else { printf("%s ", $$2); dep[x[2]] = 1; }}'); \
	for _deps in $$depends; do \
	    echo "====> $$_deps"; \
	    echo "" > ${CHECKED_FILE}; \
	    echo "" > ${PRE_DEPENDS_LIST_FILE}; \
	    ${MAKE} ${SW_MAKEOPTS} DEPENDS="$$_deps" sw-depends-req; \
	    cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else { print $$2; dep[x[2]] = 1; }}' \
	    > ${PRE_DEPENDS_LIST_FILE}.tmp; \
	    ${MAKE} ${SW_MAKEOPTS} sw-drop-invalid-depends DEPENDS_FILE="${PRE_DEPENDS_LIST_FILE}.tmp"; \
	    for _dep in ${PRE_DEPENDS}; do \
		name="$${_dep##*/}"; \
		master_origin=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} ${SW_MAKEOPTS} -V PKGORIGIN); \
		_var=$$(pkg_info -qO $$master_origin); \
		if [ -z "$$_var" ]; then \
		    installed=''; \
		else \
		    installed=$$(pkg_version -s $$_var 2>/dev/null | awk '{print $$2}'); \
		fi; \
		if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
		    touch ${SW_WRKDIR}/.installed.$$name; \
		else \
		    rm -f ${SW_WRKDIR}/.installed.$$name; \
		fi; \
	    done; \
	    for _dep in $$(cat ${PRE_DEPENDS_LIST_FILE}.tmp); do \
		if [ ! -f "${SW_WRKDIR}/.installed.$${_dep##*/}" ]; then \
		    echo "$$_dep" >> ${PRE_DEPENDS_LIST_FILE}; \
		fi; \
	    done; \
	    cd ${.CURDIR} && ${MAKE} ${SW_MAKEOPTS} DEPENDS_FILE="${PRE_DEPENDS_LIST_FILE}" \
		sw-install-options sw-fetch-depends sw-conflicts sw-install-depends; \
	    echo ""; \
	done

.if !exists(${DEPENDS_LIST_FILE})
sw-depends-list: sw-do-mkdirs
	@echo "===> Create list of depends for: ${PKGNAME}"
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@depends=$$(${MAKE} ${SW_MAKEOPTS} -V _DEPEND_DIRS | sed -e 's|${PORTSDIR}/||g'); \
        ${MAKE} ${SW_MAKEOPTS} DEPENDS="$$depends" sw-depends-req
	@cat ${CHECKED_FILE} | sort -nr | awk '{ \
		split($$2,x,"/"); if ( dep[x[2]] == 1) { next; } else {print $$2; dep[x[2]] = 1; }}' \
	 > ${DEPENDS_LIST_FILE}.tmp
	@echo "" > ${DEPENDS_LIST_FILE}
	@${MAKE} ${SW_MAKEOPTS} sw-drop-invalid-depends DEPENDS_FILE="${DEPENDS_LIST_FILE}.tmp"
	@for _dep in $$(cat ${DEPENDS_LIST_FILE}.tmp); do \
	    name="$${_dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		echo "$$_dep" >> ${DEPENDS_LIST_FILE}; \
	    fi; \
	done
.else
sw-depends-list:
.endif # DEPENDS_LIST_FILE

sw-depends-req:
	@for i in ${DEPENDS}; do \
	    if [ "$$__MKLVL__" = "20" ]; then \
		echo "Very deep recursion"; \
		exit 1; \
	    fi; \
	    name="$${i##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		sw_checked=$$(awk -v var1="$$__MKLVL__" -v var2="$$i" '{ \
			if (($$1 >= var1) && ($$2 == var2)) { print var1; exit; } \
		    }' ${CHECKED_FILE}); \
		if [ "X$$sw_checked" != "X$$__MKLVL__" ]; then \
		    echo "$$__MKLVL__ $$i" >> ${CHECKED_FILE}; \
		    depends=$$(cd ${PORTSDIR}/$$i && ${MAKE} ${SW_MAKEOPTS} -V _DEPEND_DIRS | sed -e 's|${PORTSDIR}/||g'); \
		    if [ ! -z "$$depends" ]; then \
			${MAKE} ${SW_MAKEOPTS} DEPENDS="$$depends" sw-depends-req; \
		    fi; \
		fi; \
	    fi; \
	    echo -n '.'; \
	done

sw-pre-depends-req:
	@for i in ${DEPENDS}; do \
	    if [ "$$__MKLVL__" = "20" ]; then \
		echo "Very deep recursion"; \
		exit 1; \
	    fi; \
	    name="$${i##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		echo "$$__MKLVL__ $$i" >> ${CHECKED_FILE}; \
		depends=$$(cd ${PORTSDIR}/$$i && ${MAKE} ${SW_MAKEOPTS} -V PRE_DEPENDS | sed -e 's|${PORTSDIR}/||g'); \
		if [ ! -z "$$depends" ]; then \
		    ${MAKE} ${SW_MAKEOPTS} DEPENDS="$$depends" sw-pre-depends-req; \
		fi; \
	    fi; \
	done

sw-drop-invalid-depends:
	@rm -f ${CHECKED_FILE} && ${TOUCH} ${CHECKED_FILE}
	@checklist=''; \
	for _dep in $$(cat ${DEPENDS_FILE}) ${SELF_ORIGIN}; do \
	    name="$${_dep##*/}"; \
	    if [ ! -f "${SW_WRKDIR}/.installed.$$name" ]; then \
		for i in $$(cd ${PORTSDIR}/$$_dep && ${MAKE} ${SW_MAKEOPTS} -V LIB_DEPENDS | xargs echo -n); do \
		    portpath="$${i#*:}"; \
		    name="$${i##*/}"; \
		    sw_checked=$$(awk -v var=$$i '{if ($$1 == var) {print $$1;}}' ${CHECKED_FILE}); \
		    if [ -z "$$sw_checked" ]; then \
			master_origin=$$(cd $$portpath && ${MAKE} ${SW_MAKEOPTS} -V PKGORIGIN); \
			_var=$$(pkg_info -qO $$master_origin); \
			if [ -z "$$_var" ]; then \
			    installed=''; \
			else \
			    installed=$$(pkg_version -s $$_var 2>/dev/null | awk '{print $$2}'); \
			fi; \
			if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			    lib=$${i%%:*}; \
			    case $$lib in \
				*.*.*)  pattern="`${ECHO_CMD} $$lib | ${SED} -e 's/\./\\\\./g'`" ;;\
				*.*)    pattern="$${lib%%.*}\.$${lib#*.}" ;;\
				*)  pattern="$$lib" ;;\
			    esac; \
			    if ${LDCONFIG} -r | ${GREP} -vwF -e "${PKGCOMPATDIR}" | ${GREP} -qwE -e "-l$$pattern"; then \
				touch ${SW_WRKDIR}/.installed.$$name; \
			    else \
				checklist="$$checklist $$master_origin"; \
			    fi; \
			else \
			    rm -f ${SW_WRKDIR}/.installed.$$name; \
			fi; \
			echo "$$i" >> ${CHECKED_FILE}; \
		    fi; \
		    echo -n '.'; \
		done; \
		for i in $$(cd ${PORTSDIR}/$$_dep && ${MAKE} ${SW_MAKEOPTS} -V RUN_DEPENDS -V BUILD_DEPENDS | xargs echo -n); do \
		    portpath="$${i#*:}"; \
		    name="$${i##*/}"; \
		    sw_checked=$$(awk -v var=$$i '{if ($$1 == var) {print $$1;}}' ${CHECKED_FILE}); \
		    if [ -z "$$sw_checked" ]; then \
			master_origin=$$(cd $$portpath && ${MAKE} ${SW_MAKEOPTS} -V PKGORIGIN); \
			_var=$$(pkg_info -qO $$master_origin); \
			if [ -z "$$_var" ]; then \
			    installed=''; \
			else \
			    installed=$$(pkg_version -s $$_var 2>/dev/null | awk '{print $$2}'); \
			fi; \
			if [ "$$installed" = '=' -o "$$installed" = '>' ]; then \
			    prog=$${i%%:*}; \
			    if ${EXPR} "$$prog" : \\/ >/dev/null; then \
				if [ -e "$$prog" ]; then \
				    found=1; \
				    _pkgname_self=$$(cd $$portpath && ${MAKE} ${SW_MAKEOPTS} -V PKGNAME); \
				    if [ "$$_pkgname_self" != "$$_var" ]; then \
					found=0; \
				    fi; \
				else \
				    found=0; \
				fi; \
			    else \
				prog=$$(echo $$prog | sed -e 's/[<|>|=].*//g'); \
				if ${WHICH} "$$prog" > /dev/null 2>&1 ; then \
				    found=1; \
				else \
				    found=0; \
				fi; \
			    fi; \
			    if [ $$found = 0 ]; then \
				checklist="$$checklist $$master_origin"; \
			    else \
				touch ${SW_WRKDIR}/.installed.$$name; \
			    fi; \
			else \
			    rm -f ${SW_WRKDIR}/.installed.$$name; \
			fi; \
			echo "$$i" >> ${CHECKED_FILE}; \
		    fi; \
		    echo -n '.'; \
		done; \
	    fi; \
	done; \
	if [ ! -z "$$checklist" ]; then \
	    ${MAKE} ${SW_MAKEOPTS} LIST="$$checklist" sw-delete-depends; \
	fi

.endif # PLESK_DEPENDS_MK

