#This Plesk mk-file. Need for using portupgrade for update and install standart packages 
#from ports. Packages may be installed from various repositories (defined in portupgrade's
# config file.
#Target may be redefined in Makefile of port. Definiton some targets must to be before 
#include this file.
#

.if !defined(_PREMKINCLUDED)
.include <bsd.port.pre.mk>
.endif

# Common options
# ------------------
.include <plesk.common.mk>

# Redefine main targets if ${MASTERDIR} = ${.CURDIR}
# ------------------
.if !defined(USE_NATIVE_MK)
.include <plesk.targets.mk>
.endif # USE_NATIVE_MK 

#------------------------------------------------------------------------------------------
# Target empty for compatibility with previous versions. 
#------------------------------------------------------------------------------------------
sw-install-check:

all-conflicts:

.if !target(product-pre-cmd)
product-pre-cmd: 
.endif

sw-do-mkdirs:
	@mkdir -p ${WRKDIR}
	@mkdir -p ${SW_WRKDIR}

sw-install-options:
	@if [ ! -z "${DEPENDS_FILE}" -a -f "${DEPENDS_FILE}" ]; then \
	    for _dep in $$(cat ${DEPENDS_FILE}); do \
		opts=$$(cd ${PORTSDIR}/$$_dep && make -V OPTIONS:C/\".*\"/=/g); \
		if [ ! -z "$$opts" ]; then \
		    optionsfile=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} ${SW_MAKEOPTS} -V OPTIONSFILE); \
		    if [ ! -f "$$optionsfile" ]; then \
			${MKDIR} -p $${optionsfile%/*}; \
			opts=$$(echo $$opts | sed -e 's|[Oo][Nn]|true\||g' -e 's|[Oo][Ff][Ff]|\||g'  \
							    -e 's|[[:space:]]||g' -e 's|\|| |g'); \
			pkgname=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} ${SW_MAKEOPTS} -V PKGNAME); \
			echo "_OPTIONS_READ=$$pkgname" > $$optionsfile; \
			for opt in $$opts; do \
			    _var="$${opt%=*}"; \
			    _res=$$(cd ${PORTSDIR}/$$_dep && ${MAKE} ${SW_MAKEOPTS} -V WITH_$$_var); \
			    if [ ! -z "$$_res" ]; then  \
				echo "WITH_$${_var}=true" >> $$optionsfile; \
			    else \
				echo "WITHOUT_$${_var}=true" >> $$optionsfile; \
			    fi; \
			done; \
		    fi; \
		fi; \
		echo -n "."; \
	    done; \
	fi 

# Test ports tree and throw exeption if found BROKEN 
# ports which need for own products
# ------------------
sw-test-ports:
	@echo "===> Checking ports marked as BROKEN or IGNORE"
	@if [ -z "${DEPENDS}" ]; then \
		depends=$$(${MAKE} all-depends-list | sed -e 's|${PORTSDIR}/||g'); \
	else \
		depends="${DEPENDS}"; \
	fi; \
	for dep in $$depends; do \
	    _test_cmd=$$(cd ${PORTSDIR}/$$dep && ${MAKE} ${SW_MAKEOPTS} -V FORBIDDEN); \
	    if [ ! -z "$$_test_cmd" ]; then \
		forbidden="$$forbidden $$dep"; \
	    fi; \
	    _test_cmd=$$(cd ${PORTSDIR}/$$dep && ${MAKE} ${SW_MAKEOPTS} -V IGNORE); \
	    if [ ! -z "$$_test_cmd" ]; then \
		ignored="$$ignored $$dep"; \
	    fi; \
	done; \
	if [ ! -z "$$ignored" ]; then \
	    echo "Warning: Follow ports mark as ignored but was installed now:"; \
	    for i in $$ignored; do \
		echo "   $$dep: $$(cd ${PORTSDIR}/$$dep && ${MAKE} ${SW_MAKEOPTS} -V IGNORE)"; \
	    done; \
	    echo ""; \
	fi; \
	if [ ! -z "$$forbidden" ]; then \
	    echo "ERROR!!!: Follow ports mark as FORBIDDEN:"; \
	    for i in $$forbidden; do \
		echo "   $$dep: $$(cd ${PORTSDIR}/$$dep && ${MAKE} ${SW_MAKEOPTS} -V FORBIDDEN)"; \
	    done; \
	    echo ""; \
	    echo "Installation failed"; \
	    echo "Please use ports with another tag or use ports distributed by SwSoft."; \
	    exit 1; \
	fi

.if !target(product-post-cmd)
product-post-cmd:
.endif

.if !defined(NO_SW_DEPENDS)
NO_SW_DEPENDS= 1
.include <plesk.depends.mk>
.endif

.if !defined(NO_SW_FETCH)
NO_SW_FETCH= 1
.include <plesk.fetch.mk>
.endif

.if !defined(NO_SW_CONFLICTS)
NO_SW_CONFLICTS= 1
.include <plesk.conflicts.mk>
.endif

#-------------------------------------------------------------------------------------------
# Indexes
#-------------------------------------------------------------------------------------------

do-index:
	@describe=$$(${MAKE} ${SW_MAKEOPTS} describe); \
	if [ ! -z "$$describe" ]; then \
	    _path=$$(echo $$describe | awk -F '|' '{print $$2}'); \
	    _describe_in_db=$$(tail -n 500 ${INDEXDIR}/${INDEXFILE} | grep $$_path || true); \
	    if [ "$${describe%%|*}" != "$${_describe_in_db%%|*}" ]; then \
		descr=$$(awk -F '|' -v descr="$$describe" ' \
		{ \
		    mas[$$2] = $$1; \
		} \
		END { \
		    fields_count = split(descr, fields); \
		    for(i = 1; i <= 7; i++) { \
			printf("%s|", fields[i]); \
		    }; \
		    for(i = 8; i <= 12; i++) { \
			split(fields[i], tmp_mas, " "); \
			flag = 0; \
			for(key in tmp_mas) { \
			    if (flag) { \
				printf(" "); \
			    }; \
			    if (mas[tmp_mas[key]] != "") { \
				printf("%s", mas[tmp_mas[key]]); \
			    } \
			    else { \
				cmd = sprintf("make -V PKGNAME -f %s/Makefile | xargs echo -n", tmp_mas[key]); \
				system(cmd); \
			    }; \
			    flag = 1; \
			}; \
			printf("|"); \
		    }; \
		    for(i = 13; i <= fields_count; i++) { \
			printf("%s|",fields[i]); \
		    }; \
		    printf("\n"); \
		} \
		' ${INDEXDIR}/${INDEXFILE}); \
		if [ -z "$$_describe_in_db" ]; then \
		    echo "$$descr" >> ${INDEXDIR}/${INDEXFILE}; \
		else \
		    sed -i "" -e "s#^\(.*\)|$$_path|\(.*\)#$$descr#" ${INDEXDIR}/${INDEXFILE}; \
		fi; \
	    fi; \
	else \
.           error "Inconsistent port"; \
	fi

index: do-index

#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
.if !defined(_POSTMKINCLUDED)
.include <bsd.port.post.mk>
.endif 

.if defined(USE_PHP)
.include "${PORTSDIR}/Mk/bsd.php.mk"
.endif

#<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<

sw-update-db:
	@PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    pkgdb -aFu
	@PKGTOOLS_CONF=${PKGTOOLS_CONF} \
	    portsdb -fu; 

sw-install: 
	@if [ ! -f ${SW_WRKDIR}/.installed.${PORTNAME} ]; then \
	    ${MAKE} ${SW_MAKEOPTS} sw-pre-depends sw-depends-list; \
	    ${MAKE} ${SW_MAKEOPTS} DEPENDS_FILE="${DEPENDS_LIST_FILE}" \
		sw-conflicts sw-install-options sw-fetch-depends sw-install-depends; \
	    echo "${SELF_ORIGIN}" > ${DEPENDS_LIST_FILE}; \
	    ${MAKE} ${SW_MAKEOPTS} DEPENDS_FILE="${DEPENDS_LIST_FILE}" \
		    sw-install-options sw-install-depends; \
	fi
