.if !defined(PLESK_TARGETS_MK)
PLESK_TARGETS_MK= 1

# --------------------------------------------------------------------
pre-fetch: 
	@${MKDIR} ${.CURDIR}/work

#-----------------------------------------------------------------------------------------
pre-extract: do-index

.if !target(do-extract) && defined(NO_EXTRACT)
do-extract:
	@${MKDIR} ${WRKSRC}
.endif

#Configure 
#-----------------------------------------------------------------------------------------
.if defined(NO_CONFIGURE)
configure: extract
.endif

#Build targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_BUILD)

.if !target(build)
build: configure pre-build 
	@${TOUCH} ${TOUCH_FLAGS} ${BUILD_COOKIE}
.endif

.if !target(do-build)
do-build:
.endif

.endif #NO_BUILD

#Install targets block
#-----------------------------------------------------------------------------------------
.if !defined(NO_INSTALL)

pre-install:

.if !target(do-install)
do-install: do-install-pre do-install-now do-exec do-install-post
 
do-install-pre:
. if !defined(NO_SCRIPTS) && !defined(SYSTEM_INSTALL)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} PRE-INSTALL
. endif

.if !target(do-install-now)
do-install-now:
. if !defined(NO_EXTRACT) && !defined(NO_INSTALL)
	@echo -n "---> Copying files into installation directory... "
	@${CP} -RPf ${WRKSRC}/* ${PACKAGE_INSTALLDIR}/	
	@echo "done"
.endif
.endif

do-install-post:
. if !defined(NO_SCRIPTS) && !defined(SYSTEM_INSTALL)
	@PLESK_INSTALLER_DEBUG=${VERBOSE_FLAG} \
		${SH} ${PKGINSTALL} ${PKGNAME} POST-INSTALL
. endif
.endif

.endif

#-------------------------------------------------------------------------------------------
# Set correct permissions 
#-------------------------------------------------------------------------------------------
EXEC_LIST!= [ -f ${.CURDIR}/pkg-plist ] && cat ${.CURDIR}/pkg-plist | grep '@exec ' | sed ${SED_ENV} || true

.if !target(do-exec)
do-exec:
	@for CMD in ${EXEC_LIST}; do \
		${SH} -c "$$CMD" || true; \
	done
.endif

.endif # PLESK_TARGETS_MK
